//Тип подключения дисплея: 1 - по шине I2C, 2 - десятиконтактное. Обязательно указывать ДО подключения библиотеки
//Если этого не сделать, при компиляции возникнет ошибка: "LCD type connect has not been declared"
#define _LCD_TYPE 2
#include <LCD_1602_RUS_ALL.h>
  
  const int rs = 3, en = 2, d4 = A0, d5 = A1, d6 = A2, d7 = A3; 
  LCD_1602_RUS <LiquidCrystal> lcd(rs, en, d4, d5, d6, d7); // Создаем LCD объект. Выводы: (rs, enable, d4, d5, d6, d7)
  
  #include <MFRC522.h> // for the RFID
#include <SPI.h> // for the RFID and SD card module

 
#define CS_RFID 10
#define RST_RFID 9

MFRC522 rfid(CS_RFID, RST_RFID); 
 
String uidString;

  #include <DS3231.h>                               // Подключаем библиотеку Wire  
  DS3231  rtc(SDA, SCL);                            // Инициализация DS3231
  Time t;
  String Hor, Min, Sec, Date, Mon, Year, day;
  int Dow;
 

const int checkInHour = 12;                           // Установка часов Опоздания
const int checkInMinute = 30;                         // Установка минут Опоздания
 

int userCheckInHour;
int userCheckInMinute;
 
void setup() {
  Serial.begin(9600);
  rtc.begin();                                        // Инициализировать rtc
  lcd.begin(20,4);
  while(!Serial);                                     // for Leonardo/Micro/Zero
  SPI.begin();
  rfid.PCD_Init(); 
  lcd.setCursor(2, 1);
  lcd.print("Добро пожаловать!");  
 }
 
void loop() {
  if(rfid.PICC_IsNewCardPresent()) {
    readRFID();
    verifyCheckIn();
  }
  delay(10);
}
 
void readRFID() {
  rfid.PICC_ReadCardSerial();
  lcd.clear();
  lcd.setCursor(4, 2);
  lcd.print("Номер карты: ");
  uidString = String(rfid.uid.uidByte[0]) + " " + String(rfid.uid.uidByte[1]) + " " + 
    String(rfid.uid.uidByte[2]) + " " + String(rfid.uid.uidByte[3]);
  Serial.println(uidString);
  lcd.setCursor(4, 3);
  lcd.print(uidString);
  delay(2000);
}
 
void verifyCheckIn(){
  // Присваиваем переменным значения 
  t = rtc.getTime();
  Date = t.date;              // Число
  Mon = t.mon;                // Месяц
  Year = t.year;              // Год
  Hor = t.hour;               // Часы
  Min = t.min;                // Минуты
  Sec = t.sec;                // Секунды
  Dow = t.dow;                // День недели
  
// Если число меньше 10, то добавляем 0 спереди
  if (Hor.toInt() < 10)  Hor = "0" + Hor;
  if (Min.toInt() < 10)  Min = "0" + Min;
  if (Sec.toInt() < 10)  Sec = "0" + Sec;
  if (Date.toInt() < 10) Date = "0" + Date;
  if (Mon.toInt() < 10)  Mon = "0" + Mon;

    userCheckInHour = t.hour;
    userCheckInMinute = t.min;
  if((userCheckInHour < checkInHour) || ((userCheckInHour == checkInHour)&& (userCheckInMinute <= checkInMinute))){
    lcd.clear(); 
    lcd.setCursor(5, 0);
    lcd.print((Date) + "/" + (Mon)+ "/" + (Year));
    lcd.setCursor(6, 1);
    lcd.print((Hor) + ":" + (Min)+ ":" + (Sec));  
    lcd.setCursor(2, 2);
    lcd.print("Добро пожаловать!");     
  }
  else{
    lcd.clear();
    lcd.setCursor(5, 0);
    lcd.print((Date) + "/" + (Mon)+ "/" + (Year));
    lcd.setCursor(6, 1);
    lcd.print((Hor) + ":" + (Min)+ ":" + (Sec));  
    lcd.setCursor(2, 2);
    lcd.print("Вы опоздали...");
    delay(3000);
    lcd.clear();
    lcd.setCursor(2, 2);
    lcd.print("Поднесите карту");   
  }
}
