  //Тип подключения дисплея: 1 - по шине I2C, 2 - десятиконтактное. Обязательно указывать ДО подключения библиотеки
//Если этого не сделать, при компиляции возникнет ошибка: "LCD type connect has not been declared"
  #define _LCD_TYPE 2
  #include <LCD_1602_RUS_ALL.h>
  
  const int rs = 3, en = 2, d4 = A0, d5 = A1, d6 = A2, d7 = A3; 
  LCD_1602_RUS <LiquidCrystal> lcd(rs, en, d4, d5, d6, d7); // Создаем LCD объект. Выводы: (rs, enable, d4, d5, d6, d7)

  #include <DS3231.h>                               // Подключаем библиотеку Wire  
  DS3231  rtc(SDA, SCL);                            // Инициализация DS3231
  Time t;
  String Hor, Min, Sec, Date, Mon, Year, day;
  int Dow;

  void setup() 
  {
   rtc.begin();                                     // Инициализировать rtc
   lcd.begin(20, 4);                                // устанавливаем количество столбцов и строк на дисплее
   lcd.clear();                                     // Очищаем LCD дисплей    
  }
 
 void loop() 
 {
  // Присваиваем переменным значения 
  t = rtc.getTime();
  Date = t.date;              // Число
  Mon = t.mon;                // Месяц
  Year = t.year;              // Год
  Hor = t.hour;               // Часы
  Min = t.min;                // Минуты
  Sec = t.sec;                // Секунды
  Dow = t.dow;                // День недели
  
// Если число меньше 10, то добавляем 0 спереди
  if (Hor.toInt() < 10)  Hor = "0" + Hor;
  if (Min.toInt() < 10)  Min = "0" + Min;
  if (Sec.toInt() < 10)  Sec = "0" + Sec;
  if (Date.toInt() < 10) Date = "0" + Date;
  if (Mon.toInt() < 10)  Mon = "0" + Mon;

//Вывод дней недели
  if(Dow == 0) day = "Вс";
  if(Dow == 1) day = "Пн";
  if(Dow == 2) day = "Вт";
  if(Dow == 3) day = "Ср";
  if(Dow == 4) day = "Чт";
  if(Dow == 5) day = "Пт";
  if(Dow == 6) day = "Сб";


   lcd.setCursor(4, 0);
   lcd.print(String(Date) + "/" + (Mon)+ "/" + (Year) + "(" + String(day) + ")");  
   lcd.setCursor(6, 1);
   lcd.print(String(Hor) + ":" + (Min)+ ":" + (Sec));              

  
 }
